source("Table7Function.R")
n=200
p=200
sd=2
iter=50
kmeans<-Do(n=n,p=p,K=4,R=5,iteration=iter,lambda=0,method="kmeans",rank=1,standarddeviation=sd)

bicluster1<-Do(n=n,p=p,K=4,R=5,iteration=iter,lambda=0,method="biclustering",rank=1,standarddeviation=sd)

bicluster2<-Do(n=n,p=p,K=4,R=5,iteration=iter,lambda=200,method="biclustering",rank=1,standarddeviation=sd)

bicluster3<-Do(n=n,p=p,K=4,R=5,iteration=iter,lambda=400,method="biclustering",rank=1,standarddeviation=sd)

matrixbicluster1<-Do(n=n,p=p,K=4,R=5,iteration=iter,lambda=0,method="matrix",rank=1,standarddeviation=sd,alpha=0.05,beta=0.05,max.iter=50)

matrixbicluster2<-Do(n=n,p=p,K=4,R=5,iteration=iter,lambda=15,method="matrix",rank=1,standarddeviation=sd,alpha=0.05,beta=0.05,max.iter=50)

matrixbicluster3<-Do(n=n,p=p,K=4,R=5,iteration=iter,lambda=30,method="matrix",rank=1,standarddeviation=sd,alpha=0.05,beta=0.05,max.iter=50)

matrixbicluster4<-Do(n=n,p=p,K=4,R=5,iteration=iter,lambda=0,method="matrixknown",rank=1,standarddeviation=sd,alpha=0.05,beta=0.05,max.iter=50)

matrixbicluster5<-Do(n=n,p=p,K=4,R=5,iteration=iter,lambda=100,method="matrixknown",rank=1,standarddeviation=sd,alpha=0.05,beta=0.05,max.iter=50)

matrixbicluster6<-Do(n=n,p=p,K=4,R=5,iteration=iter,lambda=250,method="matrixknown",rank=1,standarddeviation=sd,alpha=0.05,beta=0.05,max.iter=50)

plaid<-Do(n=n,p=p,K=4,R=5,iteration=iter,lambda=1200,method="plaid2",rank=1,standarddeviation=sd)

ssvd1<-Do(n=n,p=p,K=4,R=5,iteration=iter,lambda=1200,method="ssvd",rank=1,standarddeviation=sd)

ssvd2<-Do(n=n,p=p,K=4,R=5,iteration=iter,lambda=1200,method="ssvd",rank=2,standarddeviation=sd)

ssvd3<-Do(n=n,p=p,K=4,R=5,iteration=iter,lambda=1200,method="ssvd",rank=3,standarddeviation=sd)

ssvd4<-Do(n=n,p=p,K=4,R=5,iteration=iter,lambda=1200,method="ssvd",rank=4,standarddeviation=sd)




tab<-rbind(c("Method","rowCER","colCER","CorrectZero","CorrectNonZero","Sparsity","SparsityError"),c("Kmeans",paste(round(kmeans$cerrow[1],digits=4),round(kmeans$cerrow[2],digits=4),sep=","),paste(round(kmeans$cercol[1],digits=4),round(kmeans$cercol[2],digits=4),sep=","),"-","-","-","-"),c("Biclustering Lambda=0",paste(round(bicluster1$cerrow[1],digits=4),round(bicluster1$cerrow[2],digits=4),sep=","),paste(round(bicluster1$cercol[1],digits=4),round(bicluster1$cercol[2],digits=4),sep=","),"-","-","-","-"),c("Biclustering Lambda=200",paste(round(bicluster2$cerrow[1],digits=4),round(bicluster2$cerrow[2],digits=4),sep=","),paste(round(bicluster2$cercol[1],digits=4),round(bicluster2$cercol[2],digits=4),sep=","),paste(round(bicluster2$correctzero[1],digits=4),round(bicluster2$correctzero[2],digits=4),sep=","),paste(round(bicluster2$correctone[1],digits=4),round(bicluster2$correctone[2],digits=4),sep=","),paste(round(bicluster2$totalzero[1],digits=4),round(bicluster2$totalzero[2],digits=4),sep=","),paste(round(bicluster2$totalincorrect[1],digits=4),round(bicluster2$totalincorrect[2],digits=4),sep=",")),c("Biclustering Lambda=400",paste(round(bicluster3$cerrow[1],digits=4),round(bicluster3$cerrow[2],digits=4),sep=","),paste(round(bicluster3$cercol[1],digits=4),round(bicluster3$cercol[2],digits=4),sep=","),paste(round(bicluster3$correctzero[1],digits=4),round(bicluster3$correctzero[2],digits=4),sep=","),paste(round(bicluster3$correctone[1],digits=4),round(bicluster3$correctone[2],digits=4),sep=","),paste(round(bicluster3$totalzero[1],digits=4),round(bicluster3$totalzero[2],digits=4),sep=","),paste(round(bicluster3$totalincorrect[1],digits=4),round(bicluster3$totalincorrect[2],digits=4),sep=",")),c("Matrix Lambda=0",paste(round(matrixbicluster1$cerrow[1],digits=4),round(matrixbicluster1$cerrow[2],digits=4),sep=","),paste(round(matrixbicluster1$cercol[1],digits=4),round(matrixbicluster1$cercol[2],digits=4),sep=","),paste(round(matrixbicluster1$correctzero[1],digits=4),round(matrixbicluster1$correctzero[2],digits=4),sep=","),paste(round(matrixbicluster1$correctone[1],digits=4),round(matrixbicluster1$correctone[2],digits=4),sep=","),paste(round(matrixbicluster1$totalzero[1],digits=4),round(matrixbicluster1$totalzero[2],digits=4),sep=","),paste(round(matrixbicluster1$totalincorrect[1],digits=4),round(matrixbicluster1$totalincorrect[2],digits=4),sep=",")),c("Matrix  Lambda=25",paste(round(matrixbicluster2$cerrow[1],digits=4),round(matrixbicluster2$cerrow[2],digits=4),sep=","),paste(round(matrixbicluster2$cercol[1],digits=4),round(matrixbicluster2$cercol[2],digits=4),sep=","),paste(round(matrixbicluster2$correctzero[1],digits=4),round(matrixbicluster2$correctzero[2],digits=4),sep=","),paste(round(matrixbicluster2$correctone[1],digits=4),round(matrixbicluster2$correctone[2],digits=4),sep=","),paste(round(matrixbicluster2$totalzero[1],digits=4),round(matrixbicluster2$totalzero[2],digits=4),sep=","),paste(round(matrixbicluster2$totalincorrect[1],digits=4),round(matrixbicluster2$totalincorrect[2],digits=4),sep=",")),c("Matrix  Lambda=50",paste(round(matrixbicluster3$cerrow[1],digits=4),round(matrixbicluster3$cerrow[2],digits=4),sep=","),paste(round(matrixbicluster3$cercol[1],digits=4),round(matrixbicluster3$cercol[2],digits=4),sep=","),paste(round(matrixbicluster3$correctzero[1],digits=4),round(matrixbicluster3$correctzero[2],digits=4),sep=","),paste(round(matrixbicluster3$correctone[1],digits=4),round(matrixbicluster3$correctone[2],digits=4),sep=","),paste(round(matrixbicluster3$totalzero[1],digits=4),round(matrixbicluster3$totalzero[2],digits=4),sep=","),paste(round(matrixbicluster3$totalincorrect[1],digits=4),round(matrixbicluster3$totalincorrect[2],digits=4),sep=",")),c("Matrix Known",paste(round(matrixbicluster4$cerrow[1],digits=4),round(matrixbicluster4$cerrow[2],digits=4),sep=","),paste(round(matrixbicluster4$cercol[1],digits=4),round(matrixbicluster4$cercol[2],digits=4),sep=","),paste(round(matrixbicluster4$correctzero[1],digits=4),round(matrixbicluster4$correctzero[2],digits=4),sep=","),paste(round(matrixbicluster4$correctone[1],digits=4),round(matrixbicluster4$correctone[2],digits=4),sep=","),paste(round(matrixbicluster4$totalzero[1],digits=4),round(matrixbicluster4$totalzero[2],digits=4),sep=","),paste(round(matrixbicluster4$totalincorrect[1],digits=4),round(matrixbicluster4$totalincorrect[2],digits=4),sep=",")),c("Matrix Known Lambda=100",paste(round(matrixbicluster5$cerrow[1],digits=4),round(matrixbicluster5$cerrow[2],digits=4),sep=","),paste(round(matrixbicluster5$cercol[1],digits=4),round(matrixbicluster5$cercol[2],digits=4),sep=","),paste(round(matrixbicluster5$correctzero[1],digits=4),round(matrixbicluster5$correctzero[2],digits=4),sep=","),paste(round(matrixbicluster5$correctone[1],digits=4),round(matrixbicluster5$correctone[2],digits=4),sep=","),paste(round(matrixbicluster5$totalzero[1],digits=4),round(matrixbicluster5$totalzero[2],digits=4),sep=","),paste(round(matrixbicluster5$totalincorrect[1],digits=4),round(matrixbicluster5$totalincorrect[2],digits=4),sep=",")),c("Matrix Known Lambda=250",paste(round(matrixbicluster6$cerrow[1],digits=4),round(matrixbicluster6$cerrow[2],digits=4),sep=","),paste(round(matrixbicluster6$cercol[1],digits=4),round(matrixbicluster6$cercol[2],digits=4),sep=","),paste(round(matrixbicluster6$correctzero[1],digits=4),round(matrixbicluster6$correctzero[2],digits=4),sep=","),paste(round(matrixbicluster6$correctone[1],digits=4),round(matrixbicluster6$correctone[2],digits=4),sep=","),paste(round(matrixbicluster6$totalzero[1],digits=4),round(matrixbicluster6$totalzero[2],digits=4),sep=","),paste(round(matrixbicluster6$totalincorrect[1],digits=4),round(matrixbicluster6$totalincorrect[2],digits=4),sep=",")),c("Plaid","-","-",paste(round(plaid$correctzero[1],digits=4),round(plaid$correctzero[2],digits=4),sep=","),paste(round(plaid$correctone[1],digits=4),round(plaid$correctone[2],digits=4),sep=","),paste(round(plaid$totalzero[1],digits=4),round(plaid$totalzero[2],digits=4),sep=","),paste(round(plaid$totalincorrect[1],digits=4),round(plaid$totalincorrect[2],digits=4),sep=",")),c("ssvd1","-","-",paste(round(ssvd1$correctzero[1],digits=4),round(ssvd1$correctzero[2],digits=4),sep=","),paste(round(ssvd1$correctone[1],digits=4),round(ssvd1$correctone[2],digits=4),sep=","),paste(round(ssvd1$totalzero[1],digits=4),round(ssvd1$totalzero[2],digits=4),sep=","),paste(round(ssvd1$totalincorrect[1],digits=4),round(ssvd1$totalincorrect[2],digits=4),sep=",")),c("ssvd2","-","-",paste(round(ssvd2$correctzero[1],digits=4),round(ssvd2$correctzero[2],digits=4),sep=","),paste(round(ssvd2$correctone[1],digits=4),round(ssvd2$correctone[2],digits=4),sep=","),paste(round(ssvd2$totalzero[1],digits=4),round(ssvd2$totalzero[2],digits=4),sep=","),paste(round(ssvd2$totalincorrect[1],digits=4),round(ssvd2$totalincorrect[2],digits=4),sep=",")),c("ssvd3","-","-",paste(round(ssvd3$correctzero[1],digits=4),round(ssvd3$correctzero[2],digits=4),sep=","),paste(round(ssvd3$correctone[1],digits=4),round(ssvd3$correctone[2],digits=4),sep=","),paste(round(ssvd3$totalzero[1],digits=4),round(ssvd3$totalzero[2],digits=4),sep=","),paste(round(ssvd3$totalincorrect[1],digits=4),round(ssvd3$totalincorrect[2],digits=4),sep=",")),c("ssvd4","-","-",paste(round(ssvd4$correctzero[1],digits=4),round(ssvd4$correctzero[2],digits=4),sep=","),paste(round(ssvd4$correctone[1],digits=4),round(ssvd4$correctone[2],digits=4),sep=","),paste(round(ssvd4$totalzero[1],digits=4),round(ssvd4$totalzero[2],digits=4),sep=","),paste(round(ssvd4$totalincorrect[1],digits=4),round(ssvd4$totalincorrect[2],digits=4),sep=",")))


write(tab,file="matrixn200p200sd2.txt",sep=",")
